diff deseq-hts_1.0/src/deseq-hts.sh @ 0:94a108763d9e draft

deseq-hts version 1.0 wraps the DESeq 1.6.0
author vipints
date Wed, 09 May 2012 20:43:47 -0400
parents
children 8ab01cc29c4b
line wrap: on
line diff
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/deseq-hts_1.0/src/deseq-hts.sh	Wed May 09 20:43:47 2012 -0400
@@ -0,0 +1,89 @@
+#/bin/bash
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# Copyright (C) 2009-2012 Max Planck Society
+#
+
+set -e 
+
+PROG=`basename $0`
+DIR=`dirname $0`
+
+. ${DIR}/../bin/deseq_config.sh
+
+echo
+echo ${PROG}: FML http://galaxy.fml.mpg.de Galaxy wrapper for the DESeq version $DESEQ_VERSION.
+echo
+echo DESeq performs differential expression testing from RNA-Seq measurements.
+echo 
+
+ANNO_INPUT=${1}
+shift
+DESEQ_RES_FILE=${1}
+shift
+GENES_FN=${1}
+shift
+
+mkdir -p `dirname $GENES_FN`
+
+echo %%%%%%%%%%%%%%%%%%%%%%%
+echo % 1. Data preparation %
+echo %%%%%%%%%%%%%%%%%%%%%%%
+echo
+echo load the genome annotation in GFF3 format and create an annotation object
+echo
+export PYTHONPATH=$PYTHONPATH:${SCIPY_PATH}
+${PYTHON_PATH} ${DIR}/../tools/ParseGFF.py ${ANNO_INPUT} ${GENES_FN}
+${DIR}/../bin/genes_cell2struct ${GENES_FN} 2>&1
+echo 
+echo genome annotation stored in $GENES_FN
+
+echo
+echo %%%%%%%%%%%%%%%%%%%%
+echo % 2. Read counting %
+echo %%%%%%%%%%%%%%%%%%%%
+echo
+
+echo counting reads overlapping exons using given alignments
+for REPLICATE_GROUP in $@
+do
+    IFS=':'
+    for BAM_FILE in ${REPLICATE_GROUP}
+    do
+        echo
+        if [ ! -f ${BAM_FILE}.bai ]
+        then
+            echo "Indexing $BAM_FILE"
+            ${SAMTOOLS_DIR}/samtools index $BAM_FILE
+        else
+            echo "$BAM_FILE already indexed"
+        fi
+        echo
+    done
+done
+tmpfile=`mktemp --tmpdir=/tmp`
+
+echo "${DIR}/../bin/get_read_counts ${GENES_FN} $tmpfile $@"
+${DIR}/../bin/get_read_counts ${GENES_FN} $tmpfile $@ 2>&1
+
+echo
+echo %%%%%%%%%%%%%%%%%%%%%%%%%%%
+echo % 3. Differential testing %
+echo %%%%%%%%%%%%%%%%%%%%%%%%%%%
+echo
+
+echo testing genes for differential expression using given alignments
+
+echo "cat ${DIR}/../src/difftest_deseq.R | $R_PATH --slave --args $tmpfile ${DESEQ_RES_FILE} $#"
+cat ${DIR}/../src/difftest_deseq.R | $R_PATH --slave --args $tmpfile ${DESEQ_RES_FILE} $# 2> /dev/null
+
+rm $tmpfile ${tmpfile}_COUNTS.tab ${tmpfile}_CONDITIONS.tab
+echo
+echo %%%%%%%%
+echo % Done %
+echo %%%%%%%%
+echo